import java.util.Vector; 


abstract public class QVTRule extends NamedElement
{ Vector domain = new Vector(); // of Domain
  RelationalTransformation transformation;

  public QVTRule(String nme, RelationalTransformation t)
  { super(nme);
    transformation = t; 
  }

  public void addDomain(Domain d)
  { domain.add(d); }

  public void setDomain(Vector domains)
  { domain = domains; }

  public abstract boolean typeCheck(Vector types, Vector entities, Vector contexts, Vector env);

  public abstract void addTraceEntity(Vector entities); 

  public abstract Constraint toConstraint(Vector entities, Vector types);

  public abstract Constraint toInverseConstraint(Vector entities, Vector types); 
}
