import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

public interface SystemTypes
{
  public class Set
  { private Vector elements = new Vector();

  public static List select_12(List _l,List s)
  { // Implements: inds->select(i | 1 <= i & i <= s.size)
    List _results_12 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      if (1 <= i && i <= s.size())
      { _results_12.add(new Integer(i)); }
    }
    return _results_12;
  }






  public static List collect_0(List _l,List s1,List s2)
  { // implements: Integer.subrange(1,s1.size)->collect( i | s1[i] * s2[i] )
    List _results_0 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(((Double) s1.get(i - 1)).doubleValue() * ((Double) s2.get(i - 1)).doubleValue());
      if (collect_x != null) { _results_0.add(collect_x); }
    }
    return _results_0;
  }

  public static List collect_1(List _l,List s1,List s2)
  { // implements: Integer.subrange(1,s1.size)->collect( i | ( s1[i] - s2[i] )->sqr() )
    List _results_1 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(((( ((Double) s1.get(i - 1)).doubleValue() - ((Double) s2.get(i - 1)).doubleValue() ))*(( ((Double) s1.get(i - 1)).doubleValue() - ((Double) s2.get(i - 1)).doubleValue() ))));
      if (collect_x != null) { _results_1.add(collect_x); }
    }
    return _results_1;
  }

  public static List collect_2(List _l)
  { // implements: Points->collect( points_2_xx | X )
    List _results_2 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { Points points_2_xx = (Points) _l.get(_i);
      Double collect_x = new Double(points_2_xx.getX());
      if (collect_x != null) { _results_2.add(collect_x); }
    }
    return _results_2;
  }

  public static List collect_3(List _l)
  { // implements: Points->collect( points_3_xx | Y )
    List _results_3 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { Points points_3_xx = (Points) _l.get(_i);
      Double collect_x = new Double(points_3_xx.getY());
      if (collect_x != null) { _results_3.add(collect_x); }
    }
    return _results_3;
  }

  public static List collect_4(List _l,double r)
  { // implements: flows->collect( f | f.amount / ( ( 1 + r )->pow(f.timePoint) ) )
    List _results_4 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $CashFlow f = ($CashFlow) _l.get(_i);
      Double collect_x = new Double(f.getamount() / Math.pow(( 1 + r ),f.gettimePoint()));
      if (collect_x != null) { _results_4.add(collect_x); }
    }
    return _results_4;
  }

  public static List collect_5(List _l,$Bond $bondx)
  { // implements: flows->collect( f | f.amount * ( -yield * f.timePoint )->exp() )
    List _results_5 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $CashFlow f = ($CashFlow) _l.get(_i);
      Double collect_x = new Double(f.getamount() * Math.exp(( -$bondx.getyield() * f.gettimePoint() )));
      if (collect_x != null) { _results_5.add(collect_x); }
    }
    return _results_5;
  }

  public static List collect_6(List _l,$Bond $bondx)
  { // implements: flows->collect( f | ( f.timePoint * f.amount ) / ( ( 1 + yield )->pow(f.timePoint) ) )
    List _results_6 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $CashFlow f = ($CashFlow) _l.get(_i);
      Double collect_x = new Double(( f.gettimePoint() * f.getamount() ) / Math.pow(( 1 + $bondx.getyield() ),f.gettimePoint()));
      if (collect_x != null) { _results_6.add(collect_x); }
    }
    return _results_6;
  }

  public static List collect_7(List _l,$Bond $bondx)
  { // implements: flows->collect( f | f.timePoint * f.amount * ( -yield * f.timePoint )->exp() )
    List _results_7 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $CashFlow f = ($CashFlow) _l.get(_i);
      Double collect_x = new Double(f.gettimePoint() * f.getamount() * Math.exp(( -$bondx.getyield() * f.gettimePoint() )));
      if (collect_x != null) { _results_7.add(collect_x); }
    }
    return _results_7;
  }

  public static List collect_8(List _l)
  { // implements: flows->collect( $cashflow_8_xx | amount )
    List _results_8 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $CashFlow $cashflow_8_xx = ($CashFlow) _l.get(_i);
      Double collect_x = new Double($cashflow_8_xx.getamount());
      if (collect_x != null) { _results_8.add(collect_x); }
    }
    return _results_8;
  }

  public static List collect_9(List _l,$GAIndividual $gaindividualx)
  { // implements: $Bond->collect( r | ( r.yield - $Bond.nsx(r.duration,traits[1].value,traits[2].value,traits[3].value,traits[4].value,traits[5].value) )->sqr() )
    List _results_9 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $Bond r = ($Bond) _l.get(_i);
      Double collect_x = new Double(((( r.getyield() - $Bond.nsx(r.getduration(),(($GATrait) $gaindividualx.gettraits().get(0)).getvalue(),(($GATrait) $gaindividualx.gettraits().get(1)).getvalue(),(($GATrait) $gaindividualx.gettraits().get(2)).getvalue(),(($GATrait) $gaindividualx.gettraits().get(3)).getvalue(),(($GATrait) $gaindividualx.gettraits().get(4)).getvalue()) ))*(( r.getyield() - $Bond.nsx(r.getduration(),(($GATrait) $gaindividualx.gettraits().get(0)).getvalue(),(($GATrait) $gaindividualx.gettraits().get(1)).getvalue(),(($GATrait) $gaindividualx.gettraits().get(2)).getvalue(),(($GATrait) $gaindividualx.gettraits().get(3)).getvalue(),(($GATrait) $gaindividualx.gettraits().get(4)).getvalue()) ))));
      if (collect_x != null) { _results_9.add(collect_x); }
    }
    return _results_9;
  }

  public static List collect_10(List _l)
  { // implements: population->collect( $gaindividual_10_xx | fitnessval )
    List _results_10 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $GAIndividual $gaindividual_10_xx = ($GAIndividual) _l.get(_i);
      Double collect_x = new Double($gaindividual_10_xx.getfitnessval());
      if (collect_x != null) { _results_10.add(collect_x); }
    }
    return _results_10;
  }

  public static List collect_11(List _l)
  { // implements: s->collect( x | Sequence{x} )
    List _results_11 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double x = ((Double) _l.get(_i)).doubleValue();
      List collect_x = (new SystemTypes.Set()).add(new Double(x)).getElements();
      if (collect_x != null) { _results_11.add(collect_x); }
    }
    return _results_11;
  }

  public static List collect_13(List _l,List s)
  { // implements: inds->select( i | 1 <= i & i <= s.size )->collect( j | s[j] )
    List _results_13 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int j = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(((Double) s.get(j - 1)).doubleValue());
      if (collect_x != null) { _results_13.add(collect_x); }
    }
    return _results_13;
  }

  public static List collect_14(List _l)
  { // implements: s->collect( x | x.floor )
    List _results_14 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double x = ((Double) _l.get(_i)).doubleValue();
      Integer collect_x = new Integer(((int) Math.floor(x)));
      if (collect_x != null) { _results_14.add(collect_x); }
    }
    return _results_14;
  }

  public static List collect_15(List _l)
  { // implements: s->collect( x | x.round )
    List _results_15 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double x = ((Double) _l.get(_i)).doubleValue();
      Integer collect_x = new Integer(((int) Math.round(x)));
      if (collect_x != null) { _results_15.add(collect_x); }
    }
    return _results_15;
  }

  public static List collect_16(List _l)
  { // implements: s->collect( x | x.abs )
    List _results_16 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double x = ((Double) _l.get(_i)).doubleValue();
      Double collect_x = new Double(Math.abs(x));
      if (collect_x != null) { _results_16.add(collect_x); }
    }
    return _results_16;
  }

  public static List collect_17(List _l)
  { // implements: s->collect( x | x.ceil )
    List _results_17 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double x = ((Double) _l.get(_i)).doubleValue();
      Integer collect_x = new Integer(((int) Math.ceil(x)));
      if (collect_x != null) { _results_17.add(collect_x); }
    }
    return _results_17;
  }

  public static List collect_18(List _l,double v)
  { // implements: s->collect( e | e = v )
    List _results_18 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double e = ((Double) _l.get(_i)).doubleValue();
      Boolean collect_x = new Boolean(e == v);
      if (collect_x != null) { _results_18.add(collect_x); }
    }
    return _results_18;
  }

  public static List collect_19(List _l,double v)
  { // implements: s->collect( e | e <= v )
    List _results_19 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double e = ((Double) _l.get(_i)).doubleValue();
      Boolean collect_x = new Boolean(e <= v);
      if (collect_x != null) { _results_19.add(collect_x); }
    }
    return _results_19;
  }

  public static List collect_20(List _l,double v)
  { // implements: s->collect( e | e < v )
    List _results_20 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double e = ((Double) _l.get(_i)).doubleValue();
      Boolean collect_x = new Boolean(e < v);
      if (collect_x != null) { _results_20.add(collect_x); }
    }
    return _results_20;
  }

  public static List collect_21(List _l,double v)
  { // implements: s->collect( e | e + v )
    List _results_21 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double e = ((Double) _l.get(_i)).doubleValue();
      Double collect_x = new Double(e + v);
      if (collect_x != null) { _results_21.add(collect_x); }
    }
    return _results_21;
  }

  public static List collect_22(List _l,int i)
  { // implements: m->collect( row | row[i] )
    List _results_22 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { List row = (List) _l.get(_i);
      Double collect_x = new Double(((Double) row.get(i - 1)).doubleValue());
      if (collect_x != null) { _results_22.add(collect_x); }
    }
    return _results_22;
  }

  public static List collect_23(List _l,List m)
  { // implements: Integer.subrange(1,m[1].size)->collect( i | ( m->collect( row | row[i] )->sum() / m.size ) )
    List _results_23 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(( Set.sumdouble(Set.collect_22(m,i)) / m.size() ));
      if (collect_x != null) { _results_23.add(collect_x); }
    }
    return _results_23;
  }

  public static List collect_24(List _l,List s1,List s2)
  { // implements: Integer.subrange(1,s1.size)->collect( i | s1[i] + s2[i] )
    List _results_24 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(((Double) s1.get(i - 1)).doubleValue() + ((Double) s2.get(i - 1)).doubleValue());
      if (collect_x != null) { _results_24.add(collect_x); }
    }
    return _results_24;
  }

  public static List collect_25(List _l,List s1,List s2)
  { // implements: Integer.subrange(1,s1.size)->collect( i | s1[i] - s2[i] )
    List _results_25 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(((Double) s1.get(i - 1)).doubleValue() - ((Double) s2.get(i - 1)).doubleValue());
      if (collect_x != null) { _results_25.add(collect_x); }
    }
    return _results_25;
  }

  public static List collect_26(List _l,double v)
  { // implements: ss->collect( e | e * v )
    List _results_26 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double e = ((Double) _l.get(_i)).doubleValue();
      Double collect_x = new Double(e * v);
      if (collect_x != null) { _results_26.add(collect_x); }
    }
    return _results_26;
  }

  public static List collect_27(List _l,double v)
  { // implements: s->collect( sq | $Sequences.sqMult(sq,v) )
    List _results_27 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { List sq = (List) _l.get(_i);
      List collect_x = $Sequences.sqMult(sq,v);
      if (collect_x != null) { _results_27.add(collect_x); }
    }
    return _results_27;
  }

  public static List collect_28(List _l,List m1,List m2)
  { // implements: Integer.subrange(1,m1.size)->collect( i | $Sequences.ssMult(m1[i],m2[i]) )
    List _results_28 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      List collect_x = $Sequences.ssMult(((List) m1.get(i - 1)),((List) m2.get(i - 1)));
      if (collect_x != null) { _results_28.add(collect_x); }
    }
    return _results_28;
  }

  public static List collect_29(List _l,List s,List m,int i)
  { // implements: Integer.subrange(1,m.size)->collect( k | s[k] * ( m[k]->at(i) ) )
    List _results_29 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int k = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(((Double) s.get(k - 1)).doubleValue() * ((Double) ((List) m.get(k - 1)).get(i - 1)).doubleValue());
      if (collect_x != null) { _results_29.add(collect_x); }
    }
    return _results_29;
  }

  public static List collect_30(List _l,List m,List s)
  { // implements: Integer.subrange(1,sze)->collect( i | Integer.Sum(1,m.size,k,s[k] * ( m[k]->at(i) )) )
    List _results_30 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(Set.sumdouble(Set.collect_29(Set.integerSubrange(1,m.size()),s,m,i)));
      if (collect_x != null) { _results_30.add(collect_x); }
    }
    return _results_30;
  }

  public static List collect_31(List _l,List m2)
  { // implements: m1->collect( row | $Matrix.rowMult(row,m2) )
    List _results_31 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { List row = (List) _l.get(_i);
      List collect_x = $Matrix.rowMult(row,m2);
      if (collect_x != null) { _results_31.add(collect_x); }
    }
    return _results_31;
  }

  public static List collect_32(List _l)
  { // implements: m->collect( r | r[1] )
    List _results_32 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { List r = (List) _l.get(_i);
      Double collect_x = new Double(((Double) r.get(0)).doubleValue());
      if (collect_x != null) { _results_32.add(collect_x); }
    }
    return _results_32;
  }

  public static List collect_33(List _l,int j)
  { // implements: ( m.subrange(1,i - 1) ^ m.subrange(i + 1,m.size) )->collect( r | r.subrange(1,j - 1) ^ r.subrange(j + 1,r.size) )
    List _results_33 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { List r = (List) _l.get(_i);
      List collect_x = Set.concatenate(Set.subrange(r,1,j - 1),Set.subrange(r,j + 1,r.size()));
      if (collect_x != null) { _results_33.add(collect_x); }
    }
    return _results_33;
  }

  public static List collect_34(List _l,List m)
  { // implements: Integer.subrange(1,m[1].size)->collect( i | ( m[1]->at(i) ) * $Matrix.cofactor(m,1,i) )
    List _results_34 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(((Double) ((List) m.get(0)).get(i - 1)).doubleValue() * $Matrix.cofactor(m,1,i));
      if (collect_x != null) { _results_34.add(collect_x); }
    }
    return _results_34;
  }

  public static List collect_35(List _l,List m,int i)
  { // implements: Integer.subrange(1,m[i].size)->collect( j | $Matrix.cofactor(m,j,i) )
    List _results_35 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int j = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double($Matrix.cofactor(m,j,i));
      if (collect_x != null) { _results_35.add(collect_x); }
    }
    return _results_35;
  }

  public static List collect_36(List _l,List m)
  { // implements: Integer.subrange(1,m.size)->collect( i | Integer.subrange(1,m[i].size)->collect( j | $Matrix.cofactor(m,j,i) ) )
    List _results_36 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      List collect_x = Set.collect_35(Set.integerSubrange(1,((List) m.get(i - 1)).size()),m,i);
      if (collect_x != null) { _results_36.add(collect_x); }
    }
    return _results_36;
  }

  public static List collect_37(List _l,double beta1,double beta2,double beta3,double lambda1,double lambda2)
  { // implements: $Bond->collect( r | ( r.yield - $Bond.nsx(r.duration,beta1,beta2,beta3,lambda1,lambda2) )->sqr() )
    List _results_37 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $Bond r = ($Bond) _l.get(_i);
      Double collect_x = new Double(((( r.getyield() - $Bond.nsx(r.getduration(),beta1,beta2,beta3,lambda1,lambda2) ))*(( r.getyield() - $Bond.nsx(r.getduration(),beta1,beta2,beta3,lambda1,lambda2) ))));
      if (collect_x != null) { _results_37.add(collect_x); }
    }
    return _results_37;
  }

  public static List collect_38(List _l)
  { // implements: pre_points22->collect( $simplexpoint_38_xx | fval )
    List _results_38 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $SimplexPoint $simplexpoint_38_xx = ($SimplexPoint) _l.get(_i);
      Double collect_x = new Double($simplexpoint_38_xx.getfval());
      if (collect_x != null) { _results_38.add(collect_x); }
    }
    return _results_38;
  }

  public static List collect_39(List _l)
  { // implements: points.front->collect( $simplexpoint_39_xx | coords )
    List _results_39 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { $SimplexPoint $simplexpoint_39_xx = ($SimplexPoint) _l.get(_i);
      List collect_x = $simplexpoint_39_xx.getcoords();
      if (collect_x != null) { _results_39.add(collect_x); }
    }
    return _results_39;
  }


    public static boolean equals(List a, List b)
    { return a.containsAll(b) && b.containsAll(a); }


    public Set add(Object x)
    { if (x != null) { elements.add(x); }
      return this; }

    public Set add(int x)
    { elements.add(new Integer(x));
      return this; }

    public Set add(long x)
    { elements.add(new Long(x));
      return this; }

    public Set add(double x)
    { elements.add(new Double(x));
      return this; }

    public Set add(boolean x)
    { elements.add(new Boolean(x));
      return this; }

    public List getElements() { return elements; }


  public static Comparable max(List l)
  { Comparable res = null; 
    if (l.size() == 0) { return res; }
    res = (Comparable) l.get(0); 
    for (int i = 1; i < l.size(); i++)
    { Comparable e = (Comparable) l.get(i);
      if (res.compareTo(e) < 0) { res = e; } }
    return res; }


  public static Comparable min(List l)
  { Comparable res = null; 
    if (l.size() == 0) { return res; }
    res = (Comparable) l.get(0); 
    for (int i = 1; i < l.size(); i++)
    { Comparable e = (Comparable) l.get(i);
      if (res.compareTo(e) > 0) { res = e; } }
    return res; }


  public static List union(List a, List b)
  { List res = new Vector(); 
    for (int i = 0; i < a.size(); i++)
    { Object x = a.get(i); 
      if (x == null || res.contains(x)) { } else { res.add(x); } 
    }
    for (int j = 0; j < b.size(); j++)
    { Object y = b.get(j); 
      if (y == null || res.contains(y)) { } else { res.add(y); }
    }
    return res; }


  public static List subtract(List a, List b)
  { List res = new Vector(); 
    res.addAll(a);
    res.removeAll(b);
    return res; }

  public static String subtract(String a, String b)
  { String res = ""; 
    for (int i = 0; i < a.length(); i++)
    { if (b.indexOf(a.charAt(i)) < 0) { res = res + a.charAt(i); } }
    return res; }



  public static List intersection(List a, List b)
  { List res = new Vector(); 
    res.addAll(a);
    res.retainAll(b);
    return res; }



  public static List symmetricDifference(List a, List b)
  { List res = new Vector();
    for (int i = 0; i < a.size(); i++)
    { Object _a = a.get(i);
      if (b.contains(_a) || res.contains(_a)) { }
      else { res.add(_a); }
    }
    for (int j = 0; j < b.size(); j++)
    { Object _b = b.get(j);
      if (a.contains(_b) || res.contains(_b)) { }
      else { res.add(_b); }
    }
    return res;
  }



  public static boolean isUnique(List evals)
  { List vals = new Vector(); 
    for (int i = 0; i < evals.size(); i++)
    { Object ob = evals.get(i); 
      if (vals.contains(ob)) { return false; }
      vals.add(ob);
    }
    return true;
  }


  public static int sumint(List a)
  { int sum = 0; 
    for (int i = 0; i < a.size(); i++)
    { Integer x = (Integer) a.get(i); 
      if (x != null) { sum += x.intValue(); }
    } 
    return sum; }

  public static double sumdouble(List a)
  { double sum = 0.0; 
    for (int i = 0; i < a.size(); i++)
    { Double x = (Double) a.get(i); 
      if (x != null) { sum += x.doubleValue(); }
    } 
    return sum; }

  public static long sumlong(List a)
  { long sum = 0; 
    for (int i = 0; i < a.size(); i++)
    { Long x = (Long) a.get(i); 
      if (x != null) { sum += x.longValue(); }
    } 
    return sum; }

  public static String sumString(List a)
  { String sum = ""; 
    for (int i = 0; i < a.size(); i++)
    { Object x = a.get(i); 
      sum = sum + x; }
    return sum;  }



  public static int prdint(List a)
  { int res = 1; 
    for (int i = 0; i < a.size(); i++)
    { Integer x = (Integer) a.get(i); 
      if (x != null) { res *= x.intValue(); }
    } 
    return res; }

  public static double prddouble(List a)
  { double res = 1; 
    for (int i = 0; i < a.size(); i++)
    { Double x = (Double) a.get(i); 
      if (x != null) { res *= x.doubleValue(); }
    } 
    return res; }

  public static long prdlong(List a)
  { long res = 1; 
    for (int i = 0; i < a.size(); i++)
    { Long x = (Long) a.get(i); 
      if (x != null) { res *= x.longValue(); }
    }
    return res;  }



  public static List concatenate(List a, List b)
  { List res = new Vector(); 
    res.addAll(a); 
    res.addAll(b); 
    return res; }




  public static List asSet(List a)
  { List res = new Vector(); 
    for (int i = 0; i < a.size(); i++)
    { Object obj = a.get(i);
      if (res.contains(obj)) { } 
      else { res.add(obj); }
    } 
    return res; 
  }


  public static List reverse(List a)
  { List res = new Vector(); 
    for (int i = a.size() - 1; i >= 0; i--)
    { res.add(a.get(i)); } 
    return res; }

  public static String reverse(String a)
  { String res = ""; 
    for (int i = a.length() - 1; i >= 0; i--)
    { res = res + a.charAt(i); } 
    return res; }



  public static List front(List a)
  { List res = new Vector(); 
    for (int i = 0; i < a.size() - 1; i++)
    { res.add(a.get(i)); } 
    return res; }


  public static List tail(List a)
  { List res = new Vector(); 
    for (int i = 1; i < a.size(); i++)
    { res.add(a.get(i)); } 
    return res; }


    public static Object first(List v)
    { if (v.size() == 0) { return null; }
      return v.get(0);
    }


    public static Object last(List v)
    { if (v.size() == 0) { return null; }
      return v.get(v.size() - 1);
    }



  public static List sort(final List a)
  { int i = a.size()-1;
    return mergeSort(a,0,i);
  }

  static List mergeSort(final List a, int ind1, int ind2)
  { List res = new Vector();
    if (ind1 > ind2)
    { return res; }
    if (ind1 == ind2)
    { res.add(a.get(ind1));
      return res;
    }
    int mid = (ind1 + ind2)/2;
    List a1;
    List a2;
    if (mid == ind1)
    { a1 = new Vector();
      a1.add(a.get(ind1));
      a2 = mergeSort(a,mid+1,ind2);
    }
    else
    { a1 = mergeSort(a,ind1,mid-1);
      a2 = mergeSort(a,mid,ind2);
    }
    int i = 0;
    int j = 0;
    while (i < a1.size() && j < a2.size())
    { Comparable e1 = (Comparable) a1.get(i); 
      Comparable e2 = (Comparable) a2.get(j);
      if (e1.compareTo(e2) < 0) // e1 < e2
      { res.add(e1);
        i++; // get next e1
      } 
      else 
      { res.add(e2);
        j++; 
      } 
    } 
    if (i == a1.size())
    { for (int k = j; k < a2.size(); k++)
      { res.add(a2.get(k)); } 
    } 
    else 
    { for (int k = i; k < a1.size(); k++) 
      { res.add(a1.get(k)); } 
    } 
    return res;
  }


  public static List sortedBy(final List a, List f)
  { int i = a.size()-1;
    java.util.Map f_map = new java.util.HashMap();
    for (int j = 0; j < a.size(); j++)
    { f_map.put(a.get(j), f.get(j)); }
    return mergeSort(a,f_map,0,i);
  }

  static List mergeSort(final List a, java.util.Map f, int ind1, int ind2)
  { List res = new Vector();
    if (ind1 > ind2)
    { return res; }
    if (ind1 == ind2)
    { res.add(a.get(ind1));
      return res;
    }
    if (ind2 == ind1 + 1)
    { Comparable e1 = (Comparable) f.get(a.get(ind1)); 
      Comparable e2 = (Comparable) f.get(a.get(ind2));
      if (e1.compareTo(e2) < 0) // e1 < e2
      { res.add(a.get(ind1)); res.add(a.get(ind2)); return res; }
      else 
      { res.add(a.get(ind2)); res.add(a.get(ind1)); return res; }
    }
    int mid = (ind1 + ind2)/2;
    List a1;
    List a2;
    if (mid == ind1)
    { a1 = new Vector();
      a1.add(a.get(ind1));
      a2 = mergeSort(a,f,mid+1,ind2);
    }
    else
    { a1 = mergeSort(a,f,ind1,mid-1);
      a2 = mergeSort(a,f,mid,ind2);
    }
    int i = 0;
    int j = 0;
    while (i < a1.size() && j < a2.size())
    { Comparable e1 = (Comparable) f.get(a1.get(i)); 
      Comparable e2 = (Comparable) f.get(a2.get(j));
      if (e1.compareTo(e2) < 0) // e1 < e2
      { res.add(a1.get(i));
        i++; // get next e1
      } 
      else 
      { res.add(a2.get(j));
        j++; 
      } 
    } 
    if (i == a1.size())
    { for (int k = j; k < a2.size(); k++)
      { res.add(a2.get(k)); } 
    } 
    else 
    { for (int k = i; k < a1.size(); k++) 
      { res.add(a1.get(k)); } 
    } 
    return res;
  }


  public static List integerSubrange(int i, int j)
  { List tmp = new Vector(); 
    for (int k = i; k <= j; k++)
    { tmp.add(new Integer(k)); } 
    return tmp;
  }

  public static String subrange(String s, int i, int j)
  { return s.substring(i-1,j); }

  public static List subrange(List l, int i, int j)
  { List tmp = new Vector(); 
    for (int k = i-1; k < j; k++)
    { tmp.add(l.get(k)); } 
    return tmp; 
  }



  public static List prepend(List l, Object ob)
  { List res = new Vector();
    res.add(ob);
    res.addAll(l);
    return res;
  }


  public static List append(List l, Object ob)
  { List res = new Vector();
    res.addAll(l);
    res.add(ob);
    return res;
  }


  public static int count(List l, Object obj)
  { int res = 0; 
    for (int _i = 0; _i < l.size(); _i++)
    { if (obj == l.get(_i)) { res++; } 
      else if (obj != null && obj.equals(l.get(_i))) { res++; } 
    }
    return res; 
  }

  public static int count(String s, String x)
  { int res = 0; 
    if ("".equals(s)) { return res; }
    int ind = s.indexOf(x); 
    if (ind == -1) { return res; }
    String ss = s.substring(ind+1,s.length());
    res++; 
    while (ind >= 0)
    { ind = ss.indexOf(x); 
      if (ind == -1 || ss.equals("")) { return res; }
      res++; 
      ss = ss.substring(ind+1,ss.length());
    } 
    return res;
  }



  public static List characters(String str)
  { char[] _chars = str.toCharArray();
    Vector _res = new Vector();
    for (int i = 0; i < _chars.length; i++)
    { _res.add("" + _chars[i]); }
    return _res;
  }



    public static Object any(List v)
    { if (v.size() == 0) { return null; }
      return v.get(0);
    }


    public static List subcollections(List v)
    { Vector res = new Vector();
      if (v.size() == 0)
      { res.add(new Vector());
        return res;
      }
      if (v.size() == 1)
      { res.add(new Vector());
        res.add(v);
        return res;
      }
      Vector s = new Vector();
      Object x = v.get(0);
      s.addAll(v);
      s.remove(0);
      List scs = subcollections(s);
      res.addAll(scs);
      for (int i = 0; i < scs.size(); i++)
      { Vector sc = (Vector) scs.get(i);
        Vector scc = new Vector();
        scc.add(x);
        scc.addAll(sc);
        res.add(scc);
      }
      return res;
    }


  public static Vector maximalElements(List s, List v)
  { Vector res = new Vector();
    if (s.size() == 0) { return res; }
    Comparable largest = (Comparable) v.get(0);
    res.add(s.get(0));
    
    for (int i = 1; i < s.size(); i++)
    { Comparable next = (Comparable) v.get(i);
      if (largest.compareTo(next) < 0)
      { largest = next;
        res.clear();
        res.add(s.get(i));
      }
      else if (largest.compareTo(next) == 0)
      { res.add(s.get(i)); }
    }
    return res;
  }

  public static Vector minimalElements(List s, List v)
  { Vector res = new Vector();
    if (s.size() == 0) { return res; }
    Comparable smallest = (Comparable) v.get(0);
    res.add(s.get(0));
    
    for (int i = 1; i < s.size(); i++)
    { Comparable next = (Comparable) v.get(i);
      if (next.compareTo(smallest) < 0)
      { smallest = next;
        res.clear();
        res.add(s.get(i));
      }
      else if (smallest.compareTo(next) == 0)
      { res.add(s.get(i)); }
    }
    return res;
  }


  public static List intersectAll(List se)
  { List res = new Vector(); 
    if (se.size() == 0) { return res; }
    res.addAll((List) se.get(0));
    for (int i = 1; i < se.size(); i++)
    { res.retainAll((List) se.get(i)); }
    return res;
  }



  public static List unionAll(List se)
  { List res = new Vector(); 
    for (int i = 0; i < se.size(); i++)
    { List b = (List) se.get(i); 
      for (int j = 0; j < b.size(); j++)
      { Object y = b.get(j); 
        if (y == null || res.contains(y)) { } else { res.add(y); } 
      }
    }
    return res;
  }



    public static List concatenateAll(List a)
    { List res = new Vector();
      for (int i = 0; i < a.size(); i++)
      { List r = (List) a.get(i);
        res.addAll(r); 
      }
      return res;
    }



  public static List insertAt(List l, int ind, Object ob)
  { List res = new Vector();
    for (int i = 0; i < ind-1 && i < l.size(); i++)
    { res.add(l.get(i)); }
    if (ind <= l.size() + 1) { res.add(ob); }
    for (int i = ind-1; i < l.size(); i++)
    { res.add(l.get(i)); }
    return res;
  }
  public static String insertAt(String l, int ind, Object ob)
  { String res = "";
    for (int i = 0; i < ind-1 && i < l.length(); i++)
    { res = res + l.charAt(i); }
    if (ind <= l.length() + 1) { res = res + ob; }
    for (int i = ind-1; i < l.length(); i++)
    { res = res + l.charAt(i); }
    return res;
  }


 public static boolean isInteger(String str)
  { try { Integer.parseInt(str); return true; }
    catch (Exception _e) { return false; }
  }


 public static boolean isReal(String str)
  { try { double d = Double.parseDouble(str); 
          if (Double.isNaN(d)) { return false; }
          return true; }
    catch (Exception _e) { return false; }
  }

  }
}
